image: node:latest

pages:
  variables:
    BUILD_BRANCH: adacraft/main

  script:
    # TODO move to a custom docker image
    # scratch-blocks needs a java installation
    - apt-get update && apt-get install -y openjdk-11-jdk

    - git clone https://gitlab.com/adacraft/scratch-mod/scratch-blocks.git
    - git clone https://gitlab.com/adacraft/scratch-mod/scratch-gui.git
    - git clone https://gitlab.com/adacraft/scratch-mod/scratch-l10n.git
    - git clone https://gitlab.com/adacraft/scratch-mod/scratch-paint.git
    - git clone https://gitlab.com/adacraft/scratch-mod/scratch-render.git
    - git clone https://gitlab.com/adacraft/scratch-mod/scratch-svg-renderer.git
    - git clone https://gitlab.com/adacraft/scratch-mod/scratch-vm.git

    - ( cd scratch-blocks && git checkout $BUILD_BRANCH )
    - ( cd scratch-gui && git checkout $BUILD_BRANCH )
    - ( cd scratch-l10n && git checkout $BUILD_BRANCH )
    - ( cd scratch-paint && git checkout $BUILD_BRANCH )
    - ( cd scratch-render && git checkout $BUILD_BRANCH )
    - ( cd scratch-svg-renderer && git checkout $BUILD_BRANCH )
    - ( cd scratch-vm && git checkout $BUILD_BRANCH )

    - ( cd scratch-blocks && npm install )
    - ( cd scratch-l10n && npm install && npm run build )
    - ( cd scratch-paint && npm install )
    # Order is important here. There are some errors if we build "render" before
    # "svg-renderer".
    - ( cd scratch-svg-renderer && npm install )
    - ( cd scratch-render && npm install )
    - ( cd scratch-vm && npm install )

    - ( cd scratch-gui && npm install )
    - ( cd scratch-gui && NODE_ENV=production npm run build )

    - mv scratch-gui/build public

  artifacts:
    paths:
    - public
